---
title: PublicKeyCredentialRequestOptions.extensions
slug: Web/API/PublicKeyCredentialRequestOptions/extensions
tags:
  - API
  - Property
  - PublicKeyCredentialRequestOptions
  - Reference
  - Web Authentication API
  - WebAuthn
---
<p>{{APIRef("Web Authentication API")}}{{securecontext_header}}</p>

<p><strong><code>extensions</code></strong>, an optional property of the {{domxref("PublicKeyCredentialRequestOptions")}} dictionary, is an object providing the client extensions and their input values.</p>

<p>Extensions are values requesting additional processing by the client and by the authenticator. For instance, extensions may be used for:</p>

<ul>
 <li>backward compatibility with the legacy FIDO JS API,</li>
 <li>knowing the user verification process,</li>
 <li>etc.</li>
</ul>

<div class="notecard note">
<p><strong>Note:</strong> An analogous option exists for the creation operation ({{domxref("CredentialsContainer.create","navigators.credentials.create()")}}), see {{domxref("PublicKeyCredentialCreationOptions.extensions")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>extensions</em> = <em>publicKeyCredentialRequestOptions</em>.extensions</pre>

<h3 id="Value">Value</h3>

<p>An object with various keys and values.</p>

<p>Here is the current (as of March 2019) list of potential extensions which may be used during the registration operation.</p>

<div class="notecard warning">
<p><strong>Warning!</strong> As of June 2020, only <code>appid</code> is supported by <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=818303">Chrome</a> and <a href="https://docs.microsoft.com/en-us/microsoft-edge/dev-guide/windows-integration/web-authentication#api-surface">Edge</a>. Firefox does not seem to <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1370728">support any extension</a>. Also Chrome doesn't plan to support any other extension in <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=1097972">future</a></p>
</div>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Extension identifier</th>
   <th scope="col">Type</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>appid</code></td>
   <td>{{domxref("USVString")}}</td>
   <td>FIDO appID. An appID which was used with legacy FIDO JS APIs to identify the current relying party.</td>
  </tr>
  <tr>
   <td><code>txAuthSimple</code></td>
   <td>{{domxref("USVString")}}</td>
   <td>Simple transaction authorization. This text is displayed on a prompt of the authenticator before verifying the user or testing their presence. The client outputs a {{domxref("USVString")}} which is the text as it was displayed (line breaks may have been added).</td>
  </tr>
  <tr>
   <td><code>txAuthGeneric</code></td>
   <td>
    <p>An object with two properties:</p>

    <ul>
     <li><code>contentType</code> ({{domxref("USVString")}})</li>
     <li><code>content</code> ({{domxref("ArrayBuffer")}})</li>
    </ul>
   </td>
   <td>Generic transaction authorization. This is used to display an image or some non-textual content on the authenticator before verifying the user or testing their presence. The <code>contentType</code> gives the <a href="/en-US/docs/Glossary/MIME_type">MIME type</a> of the resource to be displayed while <code>content</code> gives its actual content. The client outputs the hash of the content which was displayed (hashing with the same algorithm which is used for the signature).</td>
  </tr>
  <tr>
   <td><code>uvi</code></td>
   <td>Boolean</td>
   <td>User verification index. If <code>true</code>, the client outputs an {{jsxref("ArrayBuffer")}} which contains a value uniquely identifying a user verification data record. In other words, this may be used server side to check if the current operation is based on the same biometric data that the previous authentication.</td>
  </tr>
  <tr>
   <td><code>loc</code></td>
   <td>Boolean</td>
   <td>Location. If <code>true</code>, the client outputs a {{domxref("Coordinates")}} object representing the geolocation of the authenticator.</td>
  </tr>
  <tr>
   <td><code>uvm</code></td>
   <td>Boolean</td>
   <td>User verification method. If <code>true</code>, the client outputs an array of arrays with 3 values containing information about how the user was verified (e.g. fingerprint, pin, pattern), how the key is protected, how the matcher (tool used for the authentication operation) is protected.</td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Note:</strong> Extensions are optional and different browsers may recognize different extensions. All extensions are optional for the client to process them: if a browser does not know a given extension, that will not cause any failure, the extension will not be processed.</p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var options = {
  extensions: {
    uvm: true,
    loc: false,
    txAuthSimple: "Could you please verify yourself?"
  },
  challenge: new Uint8Array([/* bytes sent from the server */])
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#dom-publickeycredentialrequestoptions-extensions','extensions')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PublicKeyCredentialRequestOptions.extensions")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PublicKeyCredential.getClientExtensionResults()")}}</li>
 <li><a href="https://w3c.github.io/webauthn/#sctn-defined-extensions">The list of all of the extensions defined in the specification</a></li>
 <li>{{domxref("PublicKeyCredentialCreationOptions.extensions")}}, the analogous option property used when creating a credential</li>
</ul>
